<template>
  <el-dialog
    v-loading="loading"
    title="设置平台"
    :center="true"
    align="left"
    top="10vh"
    width="750px"
    :close-on-click-modal="false"
    :visible.sync="showModelThis"
    element-loading-text="拼命加载中"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)"
    @close="handleClose"
  >
    <el-card style="margin-top: -20px">
      <el-row :gutter="10">
        <el-col :span="24">
          <el-form
            ref="ruleForm"
            :model="ruleForm"
            status-icon
            :size="'mini'"
            :rules="rules"
            label-width="80px"
            class="demo-ruleForm"
          >
            <el-row style="margin-bottom:20px">
              <el-col :span="24">
                <el-form-item label="真实姓名" prop="nickname">
                  <el-input
                    v-model="ruleForm.nickname"
                    :placeholder="'真实姓名'"
                    :disabled="isDetail"
                    maxlength="100"
                  />
                </el-form-item>
              </el-col>

              <el-col :span="24">
                <el-form-item label="手机号" prop="mobile">
                  <el-input
                    v-model="ruleForm.mobile"
                    :placeholder="'手机号'"
                    maxlength="11"
                    :disabled="isDetail"
                  />
                </el-form-item>
              </el-col>

              <el-col :span="24">
                <el-form-item label="平台" prop="platform_id">
                  <select-plat :allow-init="allowInit" :plat_options="plat_options" :value.sync="ruleForm.platform_id" style="width:100%" />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </el-col>
        <el-col :span="6" class="bottom-btn">
          <el-button
            type="primary"
            :size="'mini'"
            @click="submitForm"
          >保 存
          </el-button>
          <el-button :size="'mini'" @click="showModelThis = false">{{
            isDetail ? "关 闭" : "取 消"
          }}</el-button>
        </el-col>
      </el-row>
    </el-card>
  </el-dialog>
</template>
<script>
import asyncRequest from '@/apis/service/interest/account'
import companyHelper from '@/mixins/companyHelper'
import resToken from '@/mixins/resToken'
import SelectPlat from './select-plat.vue'

export default {
  name: 'Account',
  components: { SelectPlat },
  mixins: [resToken, companyHelper],
  props: ['showModel', 'id', 'isDetail', 'sitem'],
  data() {
    return {
      allowInit: false,
      companyNo: '',
      roleList: [],
      loading: false,
      title: '添加账号',
      organizeList: [],
      showModelThis: this.showModel,
      coptions: [],
      companyList: [],
      is_mainoptions: [],
      isIndeterminate: false,
      inital: true,
      departData: [],
      itemlist: [],
      ruleForm: {
        nickname: '', // 真实姓名
        mobile: '', // 手机号
        platform_id: [] // 角色id
      },
      plat_options: [],
      platformoptions: [],
      rulesThis: this.rules,
      rules: {
        platform_id: [
          {
            type: 'array',
            required: true,
            message: '请选择平台',
            trigger: 'change'
          }
        ]
      }
    }
  },
  watch: {
    showModel: function(val) {
      this.showModelThis = val
      if (val) {
        this.initForm()
      }
    },
    showModelThis(val) {
      if (!val) {
        this.$emit('cancel')
      }
    }
  },
  methods: {
    handleClose() {
      this.showModelThis = false
      this.companyNo = ''
      this.itemlist = []
      this.plat_options = []
      this.allowInit = false
    },
    handleDepartChange() {
      this.$nextTick(() => this.$refs.ruleForm.validateField('itemid'))
    },
    async initForm() {
      this.loading = true

      if (this.id === 'add') {
        await this.resetForm()
      } else {
        await this.initData()
      }
      if (this.id === 'add') {
        this.rulesThis = this.rules
      }
      this.loading = false
    },

    async getClist() {
      this.organizeList = []
      const { code, data, message } = await asyncRequest.getClist({
        size: 10000
      })
      if (code === 0) {
        this.organizeList = data
        this.recursion(this.organizeList)
      } else if (code >= 100 && code <= 104) {
        await this.logout()
      } else {
        this.$message.warning(message)
      }
    },
    handleCheckedCitiesChange(value) {
      const checkedCount = value.length
      this.ruleForm.is_all = checkedCount === this.coptions.length
      this.isIndeterminate = checkedCount > 0 && checkedCount < this.coptions.length
    },
    async companyNosearchChange(e) {
      const { code } = e
      this.companyNo = code || ''
    },
    recursion(list) {
      list.map((v) => {
        if (v && Array.isArray(v.child)) {
          v.value = v.id + ''
          v.label = v.name
          if (v.child.length === 0) {
            delete v['child']
          } else {
            this.recursion(v.child)
          }
        }
        return v
      })
    },
    async getRole() {
      const model = {
        status: '', // 状态
        level: '', // 姓名
        role_name: ''
      }
      const res = await asyncRequest.getRole(model)
      if (res && res.code === 0 && res.data) {
        this.roleList = res.data
        this.roleList.map((v1) => {
          v1.id += ''
          v1.status += ''
          return v1
        })
      }
    },
    async initData() {
      const { code, data, message } = await asyncRequest.detail({
        id: this.id
      })

      if (code === 0) {
        await this.resetForm(data)
      } else if (code >= 100 && code <= 104) {
        await this.logout()
      } else {
        this.$message.warning(message)
      }
    },
    async resetForm(sitem) {
      // 重置
      await this.$nextTick(() => {
        if (this.$refs.ruleForm) {
          this.$refs.ruleForm.resetFields()
          this.$refs.ruleForm.clearValidate()

          if (sitem) {
            const {
              item_companyNo,
              item_list,
              platform,
              nickname,
              mobile,
              id
            } = sitem

            this.plat_options = platform || []
            this.itemlist = item_list
            this.companyList = sitem.company_relaton
            this.companyNo = item_companyNo || this.companyList[0].companyCode

            this.ruleForm = {
              id,
              mobile: mobile || '',
              nickname: nickname || '',
              platform_id: platform ? platform.map(({ id }) => id) : []
            }

            this.allowInit = !platform || platform.length === 0
          }
        }
      })
    },
    async submitForm() {
      // if (!this.ruleForm.itemid || this.ruleForm.itemid.length === 0) {
      //   this.$message.warning('请选择部门')
      //   return
      // }

      await this.$refs.ruleForm.validate(async(valid) => {
        if (valid) {
          if (!this.loading) {
            this.loading = true
            const { id: uid } = this.sitem
            const { platform_id } = JSON.parse(JSON.stringify(this.ruleForm))

            const model = {
              uid,
              platform_id
            }

            const res = await asyncRequest.setplat(model)
            this.loading = false
            if (res && res.code === 0) {
              const title = this.id === 'add' ? '添加成功' : '修改成功'
              this.$notify.success({
                title,
                message: ''
              })
              this.showModelThis = false
              // 刷新
              this.$emit('refresh')
            } else if (res && res.code >= 100 && res.code <= 104) {
              await this.logout()
            } else {
              this.$message.warning(res.message)
            }
          }
        } else {
          console.log('error submit!!')
          return false
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.account {
  .bottom-btn {
    position: absolute;
    bottom: 0px;
    right: 0;
    text-align: right;
    z-index: 2;
  }
}
</style>
